<?php

// Enable error reporting;
include 'db.php';
include 'alert95th_include.php';

/*
 * Edit variables here for directories and output files etc, nothing else should need editing;
 */

$rrdtmpfile="/usr/share/cacti/site/plugins/alert95th/rrd_values";
$default_email="jwbensley@gmail.com";
$mailtemp="/tmp/alert95_mail_temp";

/*
 * End of variables
 */


/* if started from commandline, wrap parameters to $_POST and $_GET */
if (!isset($_SERVER["HTTP_HOST"])) {
  parse_str($argv[1], $_GET);
  parse_str($argv[1], $_POST);
}

?>

<!DOCTYPE html>
<html>
<head>

<title>95th Percentile Alerter</title>

<script type="text/javascript"> 

 // Lots of JavaScript below to graph the year and previous month. Also do deal with the Ajax filth.
 // Look down at your own risk...

 var XmlHttpObj;

 var thresholdid = '';
 var threshold = '';
 var description = '';

 function changeType() {
  document.getElementById("hostid").selectedIndex=0;
  document.getElementById("hostname").value = '';
  document.getElementById("graphname").value = '';
  document.getElementById("sourcename").value = '';
  document.getElementById("fields").innerHTML = '';
  // clear the graphs list
  var graphList = document.getElementById("graphid");
  for (var count = graphList.options.length-1; count >-1; count--) {
   graphList.options[count] = null;
  }
  // clear the sources list
  var sourceList = document.getElementById("sourceid");
  for (var count = sourceList.options.length-1; count >-1; count--) {
   sourceList.options[count] = null;
  }
 }

 function changeHost() {
  if (document.getElementById("hostid").value>0) {
   // Store the selected host name
   var listIndex = document.getElementById("hostid").selectedIndex;
   document.getElementById("hostname").value = document.getElementById("hostid").options[listIndex].text;
   document.getElementById("graphname").value = '';
   document.getElementById("sourcename").value = '';
   document.getElementById("fields").innerHTML = '';
   // clear the graphs list
   var graphList = document.getElementById("graphid");
   for (var count = graphList.options.length-1; count >-1; count--) {
    graphList.options[count] = null;
   }
   // clear the sources list
   var sourceList = document.getElementById("sourceid");
   for (var count = sourceList.options.length-1; count >-1; count--) {
    sourceList.options[count] = null;
   }
   var requestUrl;
   requestUrl = "ajax.php?action=get_hostid_graphs&hostid="+document.getElementById("hostid").value+"&hosttype="+
   document.getElementById("hosttype").value;
   CreateXmlHttpObj("hostgraphs");
   // verify XmlHttpObj variable was successfully initialized
   if(XmlHttpObjHostGraphs)  {
    // assign the StateChangeHandler function ( defined below in this file)
    // to be called when the state of the XmlHttpObj changes
    // receiving data back from the server is one such change
    XmlHttpObjHostGraphs.onreadystatechange = StateChangeHandler;
    // define the interaction with the server -- true for as asynchronous.
    XmlHttpObjHostGraphs.open("GET", requestUrl,  true);
    // send request to server, null arg  when using "GET"
    XmlHttpObjHostGraphs.send(null);		
   }
  }
 }

 function changeGraph() {
  if (document.getElementById("graphid").value>0) {
   var listIndex = document.getElementById("graphid").selectedIndex;
   document.getElementById("graphname").value = document.getElementById("graphid").options[listIndex].text;
   document.getElementById("fields").innerHTML = '';
   thresholdid = '';
   threshold = '';
   description = '';
   var sourceList = document.getElementById("sourceid");
   for (var count = sourceList.options.length-1; count >-1; count--) {
    sourceList.options[count] = null;
   }
   var requestUrl;
   requestUrl = "ajax.php?action=get_graphid_source_name&hostid="+document.getElementById("hostid").value+
     "&graphid="+document.getElementById("graphid").value;
   CreateXmlHttpObj("graphsource");
    if(XmlHttpObjGraphSource)  {
      XmlHttpObjGraphSource.onreadystatechange = StateChangeHandler;
      XmlHttpObjGraphSource.open("GET", requestUrl,  true);
      XmlHttpObjGraphSource.send(null);
    }
  }
 }

 function changeSource() {
  if (document.getElementById("sourceid").value>0) {
   var listIndex = document.getElementById("sourceid").selectedIndex;
   document.getElementById("sourcename").value = document.getElementById("sourceid").options[listIndex].text;
   document.getElementById("fields").innerHTML = '';
   thresholdid = '';
   threshold = '';
   description = '';
   var requestUrl;
   var listIndex = document.getElementById("sourceid").selectedIndex;
   requestUrl = "ajax.php?action=get_threshold_details&hostid="+document.getElementById("hostid").value+
     "&graphid="+document.getElementById("graphid").value+"&sourceid="+document.getElementById("sourceid").value+
     "&sourcename="+document.getElementById("sourceid").options[listIndex].text;
   CreateXmlHttpObj("sourcedetails");
    if(XmlHttpObjSourceDetails)  {
      XmlHttpObjSourceDetails.onreadystatechange = StateChangeHandler;
      XmlHttpObjSourceDetails.open("GET", requestUrl,  true);
      XmlHttpObjSourceDetails.send(null);
    }
  }
 }

 function drawForm() {
   document.getElementById("thresholdid").value = thresholdid;
   var formHTML = 'Enter alerting threshold in kilobits per second (Kbps): '+
   '<input type="text" name="threshold" id="threshold" style="width: 50px;" value="'+threshold+'" /><br>';
   formHTML += 'Enter a description like link name or customer: '+
   '<input type="text" name="description" id="description" value="'+description+'" /><br>';
   formHTML += '<br><input type="submit" value="Save"/>';
   if(thresholdid>0) { // Don't print a delete URL if there isn't a thresholdid to parse!
    formHTML += '<br><a href="?action=delete&thresholdid='+thresholdid+'&hostname='+
    document.getElementById("hostname").value+'&graphname='+document.getElementById("graphname").value+
    '&sourcename='+document.getElementById("sourcename").value+'">Delete</a>';
   }
   document.getElementById("fields").innerHTML = formHTML;
 }

 function dumpThresholds() {
  // Make an ajax query to dump the thresholds database
  document.getElementById("thresholdsdiv").innerHTML = '';
  var requestUrl;
  requestUrl = "ajax.php?action=dump_thresholds";
  CreateXmlHttpObj("datadump");
  if(XmlHttpObjDataDump)  {
   XmlHttpObjDataDump.onreadystatechange = StateChangeHandler;
   XmlHttpObjDataDump.open("GET", requestUrl,  true);
   XmlHttpObjDataDump.send(null);		
  }
 }

 function CreateXmlHttpObj(reason) {
  if (reason=="hostgraphs") {
   try { // try creating for IE (note: we don't know the user's browser type here, just attempting IE first.)
     XmlHttpObjHostGraphs = new ActiveXObject("Msxml2.XMLHTTP");
   }
   catch(e) {
    try  {
      XmlHttpObjHostGraphs = new ActiveXObject("Microsoft.XMLHTTP");
    } 
    catch(oc)  {
      XmlHttpObjHostGraphs = null;
    }
   }
   // if unable to create using IE specific code then try creating for Mozilla (FireFox) 
   if(!XmlHttpObjHostGraphs && typeof XMLHttpRequest != "undefined")  {
     XmlHttpObjHostGraphs = new XMLHttpRequest();
   }
  } else if (reason=="graphsource") {
   try { 
     XmlHttpObjGraphSource = new ActiveXObject("Msxml2.XMLHTTP");
   }
   catch(e) {
    try  {
      XmlHttpObjGraphSource = new ActiveXObject("Microsoft.XMLHTTP");
    }
    catch(oc)  {
      XmlHttpObjGraphSource = null;
    }
   }
   if(!XmlHttpObjGraphSource && typeof XMLHttpRequest != "undefined")  {
     XmlHttpObjGraphSource = new XMLHttpRequest();
   }
  } else if (reason=="sourcedetails") {
   try { 
     XmlHttpObjSourceDetails = new ActiveXObject("Msxml2.XMLHTTP");
   }
   catch(e) {
    try  {
      XmlHttpObjSourceDetails = new ActiveXObject("Microsoft.XMLHTTP");
    }
    catch(oc)  {
      XmlHttpObjSourceDetails = null;
    }
   }
   if(!XmlHttpObjSourceDetails && typeof XMLHttpRequest != "undefined")  {
     XmlHttpObjSourceDetails = new XMLHttpRequest();
   }
  } else if (reason=="datadump") {
   try {
     XmlHttpObjDataDump = new ActiveXObject("Msxml2.XMLHTTP");
   }
   catch(e) {
    try  {
      XmlHttpObjDataDump = new ActiveXObject("Microsoft.XMLHTTP");
    }
    catch(oc)  {
      XmlHttpObjDataDump = null;
    }
   }
   if(!XmlHttpObjDataDump && typeof XMLHttpRequest != "undefined")  {
     XmlHttpObjDataDump = new XMLHttpRequest();
   }
  }
 }

 // this function iis called when state of XmlHttpObj changes
 // we're interested in the state that indicates data has been
 // received from the server
 function StateChangeHandler() {
  if(typeof(XmlHttpObjHostGraphs) !== 'undefined') { 
   // state ==4 indicates receiving response data from server is completed
   if(XmlHttpObjHostGraphs.readyState == 4) {
    // To make sure valid response is received from the server, 200 means response received is OK
    if(XmlHttpObjHostGraphs.status == 200)  {			
     PopulateGraphList(XmlHttpObjHostGraphs.responseXML.documentElement);
     delete XmlHttpObjHostGraphs;
    } else {
     alert("problem retrieving data from the server, status code: "  + XmlHttpObjHostGraphs.status);
    }
   }
  }
  if(typeof(XmlHttpObjGraphSource) !== 'undefined') {
   if(XmlHttpObjGraphSource.readyState == 4) {
    if(XmlHttpObjGraphSource.status == 200)  {
     PopulateGraphSourceList(XmlHttpObjGraphSource.responseXML.documentElement);
     delete XmlHttpObjGraphSource;
    } else {
     alert("problem retrieving data from the server, status code: "  + XmlHttpObjGraphsSource.status);
    }
   }
  }
  if(typeof(XmlHttpObjSourceDetails) !== 'undefined') {
   if(XmlHttpObjSourceDetails.readyState == 4) {
    if(XmlHttpObjSourceDetails.status == 200)  {
     GetSourceDetails(XmlHttpObjSourceDetails.responseXML.documentElement);
     delete XmlHttpObjSourceDetails;
    } else {
     alert("problem retrieving data from the server, status code: "  + XmlHttpObjSourceDetails.status);
    }
   }
  }
  if(typeof(XmlHttpObjDataDump) !== 'undefined') {
   if(XmlHttpObjDataDump.readyState == 4) {
    if(XmlHttpObjDataDump.status == 200)  {
     GetDataDump(XmlHttpObjDataDump.responseXML.documentElement);
     delete XmlHttpObjDataDump;
    } else {
     alert("problem retrieving data from the server, status code: "  + XmlHttpObjDataDump.status);
    }
   }
  }
 }

 // populate the contents of the host graph dropdown list
 function PopulateGraphList(graphIDXML) {
  var graphList = document.getElementById("graphid");
  // clear the list 
  for (var count = graphList.options.length-1; count >-1; count--) {
    graphList.options[count] = null;
  }
  var graphIDs = graphIDXML.getElementsByTagName('graph');
  var idValue;
  var textValue; 
  var optionItem;
  // populate the dropdown list with data from the xml doc
  for (var count = 0; count < graphIDs.length; count++) {
   textValue = GetInnerText(graphIDs[count]);
   idValue = graphIDs[count].getAttribute("id");
   optionItem = new Option( textValue, idValue,  false, false);
   graphList.options[graphList.length] = optionItem;
  }
 }

 // populate the contents of the graph source dropdown list
 function PopulateGraphSourceList(sourceIDXML) {
  var sourceList = document.getElementById("sourceid");
  for (var count = sourceList.options.length-1; count >-1; count--) {
    sourceList.options[count] = null;
  }
  var sourceIDs = sourceIDXML.getElementsByTagName('source');
  var idValue;
  var textValue;
  var optionItem;
  for (var count = 0; count < sourceIDs.length; count++) {
   textValue = GetInnerText(sourceIDs[count]);
   idValue = sourceIDs[count].getAttribute("id");
   optionItem = new Option( textValue, idValue,  false, false);
   sourceList.options[sourceList.length] = optionItem;
  }
 }

 // get the details for a data source
 function GetSourceDetails(detailsIDXML) {
  var details = detailsIDXML.getElementsByTagName('detail');
  if(GetInnerText(details[0])!="none") {
   thresholdid = GetInnerText(details[0]);
   threshold = GetInnerText(details[1]);
   if (typeof GetInnerText(details[2]) !== 'undefined') {
    description = GetInnerText(details[2]);
   } 
  }
  drawForm();
 }

 // get the details for the thresholds data dump
 function GetDataDump(dataIDXML) {
  var data = dataIDXML.getElementsByTagName('param');
  if(GetInnerText(data[0])!="none") {
   thd = document.getElementById('thresholdsdiv');
   thd.innerHTML = '<table id="tht"><tr>'+
   '<th>Description</th><th>Hostname</th><th>Graph Name</th><th>Source Name</th><th>RRD Path</th><th>Threshold (Kbps)</th><th>&nbsp;</th></tr></table>';
   tht = document.getElementById('tht');
   var newRow = 1; // tht.rows.length-1;
   for(var count = 0; count < data.length; count++) {
     tht.insertRow(newRow);
     // Description
     tht.rows[newRow].insertCell(0);
     if (typeof GetInnerText(data[count]) !== 'undefined') {
       tht.rows[newRow].cells[0].innerHTML = GetInnerText(data[count]);
     }
     count++;
     // Hostname
     tht.rows[newRow].insertCell(1);
     tht.rows[newRow].cells[1].innerHTML = GetInnerText(data[count]);
     count++;
     // Graph name
     tht.rows[newRow].insertCell(2);
     tht.rows[newRow].cells[2].innerHTML = GetInnerText(data[count]);
     count++;
     // Source name
     tht.rows[newRow].insertCell(3);
     tht.rows[newRow].cells[3].innerHTML = GetInnerText(data[count]);
     count++;
     // RRD Path
     tht.rows[newRow].insertCell(4);
     tht.rows[newRow].cells[4].innerHTML = GetInnerText(data[count]);
     count++;
     // Threshold
     tht.rows[newRow].insertCell(5);
     tht.rows[newRow].cells[5].innerHTML = GetInnerText(data[count]);
     count++;
     // Delete link
     tht.rows[newRow].insertCell(6);
     tht.rows[newRow].cells[6].innerHTML = '<a href="?action=delete&thresholdid='+GetInnerText(data[count])+'&hostname='+
       GetInnerText(data[count-5])+'&graphname='+GetInnerText(data[count-4])+'&sourcename='+GetInnerText(data[count-3])+'">Delete</a>';
     newRow++;
   }
  }
 }

 // returns the node text value 
 function GetInnerText (node) {
  return (node.textContent || node.innerText || node.text) ;
 }

</script>

<style type="text/css">
body {font-family:verdana;}
</style>

</head>
<body>

<div>
  <a href="data.php">Single Customer Reports >></a></br></br>
</div>

<div>
  <h1>Customer 95th Percentile Alerts</h1>
</div>

<div>
 <div>
 <form name="reportform" id="reportform" method="post" action="index.php" 
  onsubmit="if (this.getAttribute('submitted')) return false; this.setAttribute('submitted','true');">
 <input type="hidden" name="action" value="report">
 <strong>Generate email report for all customers</strong><br>
 Choose month of year to report on:</span>
 <select name="reportmonth" id="reportmonth">
 <? for ($m=1;$m<=12;$m++) {
  if ($m<10) { echo '<option value="0'.$m.'"'; } else { echo '<option value="'.$m.'"'; }
  $lastmonth = date("n", strtotime("-1 month"));
    if (isset($_POST['reportmonth']) && $_POST['reportmonth']!="") {
      if ($m==$_POST['reportmonth']) { echo ' selected'; }
    } else {
      if ($m==$lastmonth) { echo ' selected'; }
    }
  echo ">".$m."</option>\n";
 } ?>
 </select>
 <select name="reportyear" id="reportyear">
 <? for ($y=2001;$y<=date("Y");$y++) {
  echo '<option value="'.$y.'"';
  if(isset($_POST['reportyear']) && $_POST['reportyear']!="") {
    if ($y==$_POST['reportyear']) { echo ' selected'; }
  } else {
    if ($y==date("Y")) { echo ' selected'; }
  }
  echo ">".$y."</option>\n";
 } ?>
 </select><br>
 Enter a report recipient email address: <input type="text" name="email" id="email" value="<?
  if(isset($_POST['email']) && $_POST['email']!="") {
    echo $_POST['email'];
  } else {
    echo $default_email;
  }
?>"/><br>
 <input type="submit" id="genreport" name="genreport" value="generate">
 </form>
 </div>
</div>

<?
if (isset($_POST['action']) && $_POST['action']=="report" && isset($_POST['reportyear']) && isset($_POST['reportmonth'])) {
  $reportstart=date("U", mktime(0, 0, 0, $_POST['reportmonth'], 1, $_POST['reportyear']));
  $reportend=date("U", mktime(23, 55, 0, $_POST['reportmonth']+1, 0, $_POST['reportyear']));
  $reportemail = $_POST['email'];

  $sql = "SELECT rrd_path, threshold, sourcename, hostname, description, graphname FROM `tblThresholds` ORDER BY description Asc";
  $db = mysql_select_db("95thalerts");
  $result = mysql_query($sql);
  if(!$result) {
    die("Couldn't get threshold records: ".mysql_error());
  }

  $handle = fopen("$mailtemp", "w");
  fwrite($handle, "Script running at: ".date("Y-m-d H:i:s")."\n");
  fwrite($handle, "Check for date period from ".date("Y-m-d H:i:s", $reportstart)." to ".date("Y-m-d H:i:s", $reportend)."\n\n");
  $mailsubject="Monthly 95th Usages ".date("Y-m", $reportstart);
  # Number of customers over their useage
  $overcustomer=0;
  $totalover=0;

  while($row=mysql_fetch_assoc($result)) {
    $rrdresults = check95th_threshold($reportstart, $reportend, $row['rrd_path'], $row['sourcename'], $rrdtmpfile);
    $threshold_mbps = $row['threshold']/1000;
    if($rrdresults[0] > $threshold_mbps) {
      fwrite($handle, "Service Description: ".$row['description']."\n");
      fwrite($handle, "Device: ".$row['hostname']."\n");
      fwrite($handle, "Port: ".$row['graphname']."\n");
      fwrite($handle, "95th threshold: ".$threshold_mbps."Mbps\n");
      fwrite($handle, "95th% this period: ".$rrdresults[0]."Mbps\n");
      fwrite($handle, "Peak: ".trim($rrdresults[3])." ".trim($rrdresults[4])."\n");
      fwrite($handle, "Transfered: ".($rrdresults[1])." ".($rrdresults[2])."\n\n");
      $overcustomer+=1;
      $totalover+=($rrdresults[0]-$threshold_mbps);
    }
  }

  
  fwrite($handle, "Script finished at: ".date("Y-m-d H:i:s")."\n");
  if($overcustomer>0) { 
    fwrite($handle, $overcustomer." customer(s) went over their usage this month.\n");
    fwrite($handle, "Total unbilled overage is ".$totalover.".Mbps\n");
    $cmd="cat $mailtemp | mail -s \"$mailsubject\" \"$reportemail\"";
    exec($cmd);
    echo "<i>Report sent!</i>";
  } else {
    echo "<i>No report send!</i>";
}

  fclose($handle);
  unlink("$mailtemp");

}
?>

<div><br>
<strong>Edit a thresholds for the report</strong>
<?
if (isset($_POST['action']) && $_POST['action']=="threshold" && isset($_POST['thresholdid']) && 
    isset($_POST['threshold'])) {

  if((int)$_POST['thresholdid']>0) {

  // Update an existing entry 
  $sql = "UPDATE `tblThresholds` SET threshold=".$_POST['threshold'].", description='".$_POST['description']."', graphname='".$_POST['graphname']."' ".
         "WHERE thresholdid=".$_POST['thresholdid'];
  $db = mysql_select_db("95thalerts");
  $result = mysql_query($sql);
  if(!$result) {
   die("Couldn't update threshold: ".mysql_error());
  }
  echo "<p><i>Updated threshold: </i> ".$_POST['hostname']." - ".$_POST['graphname']." - ".$_POST['sourcename']."<br>Threshold: ".
        $_POST['threshold']."</p>";

 } else {

  // Grab the rrd file path for this data source first
  $sql = "SELECT DISTINCT rrd_path from `poller_item` WHERE host_id = ".$_POST['hostid']." AND local_data_id = ".$_POST['sourceid'].
    " LIMIT 0,1";
  $db = mysql_select_db("cacti");
  $result = mysql_query($sql);
  if(!$result) {
   die("Couldn't get rrd path for data source: ".mysql_error());
  }
  $rrd_path=mysql_fetch_assoc($result);

  // Insert a new entry
  $sql = "INSERT INTO `tblThresholds` (thresholdid, threshold, description, hostid, hostname, graphid, graphname, sourceid,".
    " sourcename, dateadded, rrd_path) values(0, ".$_POST['threshold'].", '".$_POST['description']."', '".$_POST['hostid']."', '".
    $_POST['hostname']."', ".$_POST['graphid'].", '".$_POST['graphname']."', ".$_POST['sourceid'].", '".$_POST['sourcename']."', ".
    "NOW(), '".$rrd_path['rrd_path']."')";
  $db = mysql_select_db("95thalerts");
  $result = mysql_query($sql);
  if(!$result) {
   die("Couldn't update threshold: ".mysql_error());
  }
  echo "<p><i>Added threshold: </i> ".$_POST['hostname']." - ".$_POST['graphname']." - ".$_POST['sourcename']."<br>Threshold: ".
       $_POST['threshold']."</p>";
 }
}

if (isset($_GET['action']) && $_GET['action']=="delete" && isset($_GET['thresholdid'])) {
 $sql = "DELETE FROM `tblThresholds` WHERE thresholdid = ".$_GET['thresholdid'];
 $db = mysql_select_db("95thalerts");
 $result = mysql_query($sql);
 if(!$result) {
  die("Couldn't delete threshold: ".mysql_error());
 }
 echo "<p><i>Deleted threshold: </i> ".$_GET['hostname']." - ".$_GET['graphname']." - ".$_GET['sourcename']."</p>";
}
?>
</div>
<div>
<form method="post" action="index.php">
<input type="hidden" name="action" id="action" value="threshold">
<input type="hidden" name="thresholdid" id="thresholdid" value="">
<input type="hidden" name="hostname" id="hostname" value="">
<input type="hidden" name="graphname" id="graphname" value="">
<input type="hidden" name="sourcename" id="sourcename" value="">

Host Type: <select name="hosttype" id="hosttype" onchange="javascript:changeType();">
<option value="cisco" selected>Cisco</option>
<option value="m0n0wall">m0n0wall</option>
</select><br>

<?
// Query for Cacti tree names and IDs
$query = "SELECT id, description, hostname FROM `host` ORDER BY description";
$db = mysql_select_db("cacti");
$result = mysql_query($query);
if(!$result) {
  die("Couldn't get list of hosts: ".mysql_error());
}

echo "Select Host: <select name=\"hostid\" id=\"hostid\" onchange=\"javascript:changeHost();\">\n";
echo "<option value=\"\" selected></option>\n";
while ($row=mysql_fetch_assoc($result)) {
  echo "<option value=\"".$row['id']."\">".$row['description']." | ".$row['hostname']."</option> \n";
}

echo '</select>';
?>

<br>
Select graph: <select name="graphid" id="graphid" onchange="javascript:changeGraph();">
</select>

<br>
Select graph source: <select name="sourceid" id="sourceid" onchange="javascript:changeSource();">
</select>
<br>

<br>
<div name="fields" id="fields"></div>
</form>
</div>
<div>
<strong>Display thresholds</strong><br>
<input type="button" value="Refresh" onclick="javascript:dumpThresholds();"/><br>
<div name="thresholdsdiv" id="thresholdsdiv"></div>
</div>
</body>
</html>

